% Dynamic SISO System
if 1>2
load spmdata
NetDef = ['HHHHH'
          'L----']; 
NN = [2 2 1];

clear trparms;
trparms.maxiter = 100;
%trparms.critmin = 0;
%trparms.critterm = 1e-7;
trparms.gradterm = 1e-3;
trparms.paramterm = 1e-3; % 1e-2 % 1e-2

%trparms.D = [1e-4 1e-5];
trparms.D = [rand(31,1)']*1e-4;
trparms.lambda = 1;
trparms.skip = 10;
trparms.infolevel=1;
rand('seed',0);
W1=rand(5,5); W2=rand(1,6);
[W1,W2,NSSEvec,iteration]=nnarx(NetDef,NN,[],[],trparms,y1,u1);
Efpe = nnfpe('nnarx',NetDef,W1,W2,u1,y1,NN)
trparms.maxiter=0;
Eloo = nnloo(NetDef,W1,W2,u1,y1,NN)
[theta_data,NSSEvec,FPEvec,NSSEtestvec,deff,pvec]=...
           nnprune('nnarx',NetDef,W1,W2,u1,y1,NN,[],[],y2,y2)

%[W1,W2,NSSEvec,iteration,lambda]=nnoe(NetDef,NN,[],[],trparms,y1,u1);

NetDeff = ['HHHH';'L---']; NetDefg = ['HHH';'L--'];
%[W1f,W2f,W1g,W2g,critvec,iteration,lambda]=...
%                     nniol(NetDeff,NetDefg,NN,[],[],[],[],trparms,y1,u2);
W1=rand(5,7); W2=rand(1,6);
NN = [2 2 2 1];
%[W1,W2,NSSEvec,iter,lambda]=nnarmax2(NetDef,NN,[],[],trparms,y1,u1);
%[W1,W2,Chat,NSSEvec,iter,lambda]=nnarmax1(NetDef,NN,[],[],[],trparms,y1,u1);

trparms=settrain(trparms,'method','ct');
%[W1,W2,Chat,NSSEvec,iter]=nnrarmx1(NetDef,NN,[],[],[],[],y1,u1);
%[W1,W2,NSSEvec,iter]=nnrarmx2(NetDef,NN,[],[],trparms,y1,u1);
NetDef = ['HHHH';'LL--']; 
%W1=rand(4,5); W2=rand(2,5);
%[W1,W2,obsidx,NSSEvec,iter,lambda]=nnssif(NetDef,2,[],[],[],trparms,y1,u1);

end

% Mini curve fitting example
if 1>2
PHI=0:0.25:6;
Y=sin(PHI);
PHI1 = PHI(:,1:2:25);
Y1   = Y(:,1:2:25);
PHI2 = PHI(:,2:2:24);
Y2   = Y(:,2:2:24);
  rand('seed',0);
  W1         = rand(4,2);  % Weights to hidden layer 
  W2         = rand(1,5);  % Weights to output
  NetDef = ['HHHH'       
            'L---'];       % The top row represents the structure of 
                           % the hidden layer. The bottom row represents
                           % the output structure.
  trparms = settrain;      % Set training parameters to default values
%  trparms=settrain(trparms,'maxiter',1000,'eta',0.01);
%  trparms.infolevel=1;
trparms.maxiter=20;
  %  trparms=settrain(trparms,'paramterm',0.001,'gradterm',0.001,'critterm',0.02);
  [W11,W21,PI,iter]=marq(NetDef,W1,W2,PHI1,Y1,trparms);
%[W13,W23,PI3,iter3]=marqlm(NetDef,W1,W2,PHI1,Y1,trparms);  
% [W1,W2,PI_vector,iter]=incbp(NetDef,W1,W2,PHI1,Y1,trparms);
end

% Bigger curve fitting example
if 1>2
   PHI1=2*pi*rand(1,300);
   Y1 = sin(PHI1) + 0.2*randn(1,300);
   PHI2=2*pi*rand(1,300);
   Y2 = sin(PHI2) + 0.2*randn(1,300);
   trparms=settrain;
   trparms=settrain(trparms,'D',0.01*rand(1,16));
   W1=rand(5,2)-0.5;
   W2=rand(1,6)-0.5;
   NetDef=['HHHHH';'L----'];
   trparms=settrain;
   trparms.D=1e-2;
   [W11,W21,PI,iter]=marq(NetDef,[],[],PHI1,Y1,trparms);
   
   FPE=fpe(NetDef,W11,W21,PHI1,Y1);

   [theta_data,NSSEvec,FPEvec,NSSEtestvec,deff,pvec]=...
                     obsprune(NetDef,W11,W21,PHI1,Y1,[],[],PHI2,Y2);
end

% MIMO curvefitting example
if 1>2
   PHI1=2*pi*rand(2,300);
   Y1 = [sin(PHI1(1,:));cos(PHI1(2,:))] + 0.2*randn(2,300);
   PHI2=2*pi*rand(2,300);
   Y2 = [sin(PHI2(1,:));cos(PHI2(2,:))] + 0.2*randn(2,300);
   W1=rand(6,3)-0.5;
   W2=rand(2,7)-0.5;
   trparms=settrain;
   trparms=settrain(trparms,'Infolevel',1,'D',0);
   NetDef=['HHHHHH';'LL----'];
   %   [W11,W21,PI,iter]=marq(NetDef,W1,W2,flipud(PHI1),flipud(Y1),trparms);
   trparms.maxiter=500;
[W11,W21,PI,iter]=marq(NetDef,W1,W2,PHI1,Y1,trparms);
   trparms=settrain(trparms,'maxiter',80);
   [W1,W2,Gamma,lambda]=igls(NetDef,W11,W21,[],[],PHI1,Y1);
   %   [W1,W2,Gamma,lambda]=igls(NetDef,W11,W21,trparms,[],flipud(PHI1),flipud(Y1));
  % w2=sqrtm(Gamma)*W2; nneval(NetDef,W1,w2,PHI1,Y1);
end


% Dynamic MIMO system
if 1>2
load spmdata
NetDef = ['HHHHH'
          'LL---']; 
NN = [2 2 1;2 0 0];
%NN = [2 2 2 1 1;2 0 0 0 0];
U1 = [u1;sin(u1)];
Y1 = [y1;y1.^2];

clear trparms;
trparms.maxiter = 100;
%trparms.critmin = 0;
%trparms.critterm = 1e-7;
trparms.gradterm = 1e-3;
trparms.paramterm = 1e-3; % 1e-2 % 1e-2

trparms.D = [1e-4 1e-5];
%trparms.D = [rand(31,1)']*1e-4;
trparms.lambda = 1;
trparms.skip = 10;
trparms.infolevel=1;
rand('seed',0);
[W1,W2,NSSEvec,iteration]=nnarxm(NetDef,NN,[],[],trparms,[],Y1,u1);
%[W1,W2,NSSEvec,iteration]=nnarxm(NetDef,NN,[],[],[],[],Y1,U1);
[W1,W2,Gamma,lambda]=nnigls(NetDef,NN,W1,W2,[],[],Y1,u1);
%nnvalid('nnarxm',NetDef,NN,W1,sqrtm(Gamma)*W2,[],Y1,U1);
Gamma=[];
nnvalid('nnarxm',NetDef,NN,W1,W2,Gamma,Y1,u1);

[W1,W2,obsidx]=nnssif(NetDef,2,[],[],[],trparms,Y1,U1);
[Yhat,NSSE] = ifvalid(NetDef,2,W1,W2,[],Y1,U1)
end

% Test dscale+wrescale
if 0>1,
load spmdata
u1 = 0.1*u1; u2 = 0.1*u2;
y1 = 5*y1; y2 = 5*y2;

NetDef = ['HHHHH'
          'L----']; 
%NN = [2 2 1;2 0 0];
NN = [2 2 2 1 1];       
%NN = [2 2 2 1 1;2 0 0 0 0];
U1 = [u1;sin(u1)];U2 = [u2;sin(u2)];
Y1 = [y1]; Y2 = [y2];
%Y1 = [y1;y1.^2]; Y2 = [y2;y2.^2];

[u1s,uscale] = dscale(U1);
[y1s,yscale] = dscale(Y1);

[u2s,uscale] = dscale(U2,uscale);
[y2s,yscale] = dscale(Y2,yscale);

clear trparms;
trparms.maxiter = 100;
rand('seed',0);
method = 'nnarmax1';
%[W1s,W2s,NSSEvec,iteration]=nnarx(NetDef,NN,[],[],trparms,y1s,u1s);

NN = [2 2 2 3 1 1];
[W1s,W2s,Chat,NSSEvec,iteration]=nnarmax1(NetDef,NN,[],[],[],trparms,y1s,u1s);

[W1,W2]=wrescale(method,W1s,W2s,uscale,yscale,NN);
[Yhats,NSSEs] = nnvalid(method,NetDef,NN,W1s,W2s,y1s,u1s);
[Yhat,NSSE] = nnvalid(method,NetDef,NN,W1,W2,Y1,U1);
close all
NSSEs*yscale(2)^2-NSSE
es = y1s(4:end)-Yhats;
e = Y1(4:end)-Yhat;
plot(e-es*yscale(2));
end

% Test rescale on iol models and inverse models
if 2>1,
load spmdata
u1 = 0.1*u1; u2 = 0.1*u2;
y1 = 5*y1; y2 = 5*y2;

NetDeff = ['HHHHH'
          'L----']; 
NetDefg = ['HHH'
          'L--'];        
NN = [2 2 1];

[u1s,uscale] = dscale(u1);
[y1s,yscale] = dscale(y1);

[u2s,uscale] = dscale(u2,uscale);
[y2s,yscale] = dscale(y2,yscale);

clear trparms;
trparms.maxiter = 100;
rand('seed',0);
method = 'nniol';
[W1fs,W2fs,W1gs,W2gs,NSSEvec,iteration]=...
   nniol(NetDeff,NetDefg,NN,[],[],[],[],trparms,y1s,u1s);
[W1,W2]=wrescale(method,{W1fs,W1gs},{W2fs,W2gs},uscale,yscale,NN);

[Yhats,NSSEs] = ioleval(NetDeff,NetDefg,NN,W1fs,W2fs,W1gs,W2gs,y1s,u1s);

NetDeff2 = ['HHHHHHHH'
           'L-------']; 
[Yhat,NSSE] = ioleval(NetDeff2,NetDefg,NN,W1{1},W2{1},W1{2},W2{2},y1,u1);

close all
NSSEs*yscale(2)^2-NSSE
es = y1s(3:end)-Yhats;
e = y1(3:end)-Yhat;
plot(e-es*yscale(2));
end

% Test if inverse and wrescale
if 2>1
  [Y,U]=experim;close
  N2=length(U);
  N1=floor(N2/2);
  Y1 = Y(1:N1)';
  U1 = U(1:N1)';
  Y2 = Y(N1+1:N2)';
  U2 = U(N1+1:N2)';
  [u1s,uscale] = dscale(U1);
  [y1s,yscale] = dscale(Y1);
  
  NetDefi  = ['HHHHH';'L----'];
  NN      = [3 2 1];
  [W1i,W2i,PI_vector,iteration,lambda]=general(NetDefi,NN,[],[],trparms,y1s,u1s);
  [Yhats,PIs] = invsim(NetDefi,NN,W1i,W2i,y1s,u1s);
  
  [W1,W2]=wrescale('inverse',W1i,W2i,uscale,yscale,NN);
  [Yhat,PI] = invsim(NetDefi,NN,W1,W2,Y1,U1);
  PIs*uscale(2)^2-PI
  es = u1s(4:end)-Yhats;
  e = U1(4:end)-Yhat;
  plot(e-es*uscale(2));
end